%define		pname maildrop
%define		pversion 1.8.0
%define 	bversion 106
%define		rpmrelease iworx

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_fdr_80   0
%define		build_fdr_90   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0
%define		build_rhe_5x   0
%define		build_rhe_6x   0
%define		build_rhe_7x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_fdr80: 	%{expand: %%define build_fdr_80   1}}
%{?_with_fdr90: 	%{expand: %%define build_fdr_90   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}
%{?_with_rhe5x: 	%{expand: %%define build_rhe_5x   1}}
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}
%{?_with_rhe7x: 	%{expand: %%define build_rhe_7x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_80}
%define		oscode fdr80
%define 	ostype Fedora Core 8
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
Epoch:		1
%endif

%if %{build_fdr_90}
%define		oscode fdr90
%define 	ostype Fedora Core 9
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
Epoch:		1
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_5x}
%define		oscode rhe5x
%define 	ostype RedHat Enterprise 5.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_7x}
%define		oscode rhe7x
%define 	ostype RedHat Enterprise 7.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	Maildrop mail filter/mail delivery agent
Name:		maildrop
Version:	%{pversion}
Release:	%{release}
License:	GPL

Group:		System/Servers
Source0:	maildrop-%{pversion}.tar.bz2
URL:		http://www.flounder.net/~mrsam/maildrop/

Distribution:	InterWorx-HAL
Vendor:		    INTERWORX L.L.C.
Packager:	    Paul Oehler <poehler@interworx.com>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

BuildRequires:	vpopmail >= 5.3.8
BuildRequires:  courier-imap

%package devel
Summary:	Development tools for handling E-mail messages
Group:		Development/C
Requires:	%{name} >= %{pversion}-%{release}

%description
Maildrop  is a combination  mail  filter/mail  delivery agent.
Maildrop reads  the message  to be delivered  to your mailbox,
optionally reads instructions from a file  how filter incoming
mail, then based on these  instructions may deliver mail to an
alternate  mailbox,  or  forward  it,  instead of dropping the
message into your mailbox.

Maildrop uses a structured, real, meta-programming language in
order to define filtering instructions. Its basic features are
fast and efficient.  At sites which  carry a  light  load, the
more advanced, CPU-demanding,  features  can be  used to build
very  sophisticated  mail  filters.  Maildrop deployments have
been  reported  at  sites  that  support  as  many  as  30,000
mailboxes.

%description devel
The maildrop-devel package contains the  libraries and  header
files that can be  useful in  developing  software that  works
with or processes E-mail messages.

Install the maildrop-devel  package  if you  want  to  develop
applications which use or process E-mail messages.

%define name maildrop

%prep

%setup -q -n %{name}-%{pversion}

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"
export CPPFLAGS="%{ccflags}"

./configure                                  \
	--prefix=%{_prefix}                  \
	--bindir=%{_bindir}                  \
	--mandir=%{_mandir}                  \
	--localstatedir=%{_localstatedir}    \
	--libdir=%{_libdir}                  \
	--datadir=%{_datadir}                \
	--includedir=%{_includedir}          \
	--sysconfdir=%{_sysconfdir}          \
	--with-devel                         \
	--enable-userdb                      \
	--enable-maildirquota                \
	--enable-trashquota                  \
	--enable-restrict-trusted=0          \
	--enable-sendmail=/usr/sbin/sendmail \
 	--enable-syslog=1                    \
	--enable-trusted-users='root mail daemon postmaster qmaild mmdf'

%build
%{__make} %{?_smp_mflags}

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
mkdir -p %{buildroot}

make install-strip DESTDIR=%{buildroot} MAILDROPUID='' MAILDROPGID=''

find %{buildroot}%{_mandir} ! -type d -print | perl -e '
 while (<>)
  {
    $f=$_;  
    chop $f;
    next if $f =~ /\.gz$/;
    if (-l $f)
    {
        $f2=readlink($f);
        unlink($f);
        symlink "$f2.gz", "$f.gz";
    }
    else
    {
        system("gzip <$f >$f.gz");
        unlink($f);
    }
 } '

mkdir htmldoc
cp %{buildroot}%{_datadir}/maildrop/html/* htmldoc
rm -rf %{buildroot}%{_datadir}/maildrop/html
rm -rf %{buildroot}%{_bindir}/deliverquota
rm -rf %{buildroot}%{_bindir}/mailbot
rm -rf %{buildroot}%{_bindir}/maildirmake
rm -rf %{buildroot}%{_mandir}/man1
rm -rf %{buildroot}%{_mandir}/man5
rm -rf %{buildroot}%{_mandir}/man7
rm -rf %{buildroot}%{_mandir}/man8

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: maildrop package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%files
%defattr(-, bin, bin)
%doc maildir/README.maildirquota.html maildir/README.maildirquota.txt
%doc COPYING README README.postfix INSTALL NEWS UPGRADE ChangeLog maildroptips.txt
%doc htmldoc/*
%{_datadir}/maildrop
%attr(0755, root, root) %{_bindir}/*

%files devel
%defattr(-, bin, bin)
%{_mandir}/man3/*
%attr(0644, root, root) %{_includedir}/*
%attr(0644, root, root) %{_libdir}/*

%changelog
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Fri May 10 2013 Paul Oehler <poehler@interworx.com>
- Got rid of unneeded suid on binaries
* Wed Jan 18 2012 Paul Oehler <poehler@interworx.com>
- Added --enable-trashquota compile option
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- added support for Fedora 8
* Sat Sep 11 2004 Chris Wells <clwells@nexcess.net>
- Repackaged for InterWorx-CP
* Thu Jun 03 2004 Nick Hemmesch <nick@ndhsoft.com> 1.6.3-1.2.2
- Add Fedora Core 2 support
* Thu Jun 03 2004 Nick Hemmesch <nick@ndhsoft.com> 1.6.3-1.2.1
- Update to maildrop-1.6.3
* Mon Dec 29 2003 Nick Hemmesch <nick@ndhsoft.com> 1.5.3-1.0.3
- Add Fedora Core 1 support
* Sun Nov 23 2003 Nick Hemmesch <nick@ndhsoft.com> 1.5.3-1.0.2
- Add Trustix 2.0 support
* Sat Apr 26 2003 Miguel Beccari <miguel.beccari@clikka.com> 1.5.3-1.0.1
- Last version 1.5.3
- Clean-ups on SPEC compilation banner, better gcc detects
- Detect gcc-3.2.3
- Red Hat Linux 9.0 support (nick@ndhsoft.com)
- Gnu/Linux Mandrake 9.2 support
* Wed Apr 02 2003 Miguel Beccari <miguel.beccari@clikka.com> 1.5.2-1.0.1
- Conectiva 7.0 support
- Cleans up
* Sun Feb 15 2003 Nick Hemmesch <nick@ndhsoft.com> 1.4.0-1.0.3
- Support for Red Hat 8.0
* Sat Feb 01 2003 Miguel Beccari <miguel.beccari@clikka.com> 1.4.0-1.0.2
- Redo Macros to prepare supporting larger RPM OS.
  We could be able to compile (and use) packages under every RPM based
  distribution: we just need to write right requirements.
- Improved files section with right permissions and owners.
* Sat Jan 25 2003 Miguel Beccari <miguel.beccari@clikka.com> 1.4.0-1.0.1
- Added MDK 9.1 support
- Try to use gcc-3.2.1
- Added very little patch to compile with newest GLIBC
- Support dor new RPM-4.0.4
* Thu Oct 22 2002 Miguel Beccari <miguel.beccari@clikka.com> 1.4.0-1.0.0beta
- Toaster release
